OUT_SETTINGS = {}; 

var KeyPts = [];

function addKeyPoint() {
	if (KeyPts.length == 0)
		KeyPts.push({colorValue:0,lineIndex:0, id:""});
	else {
		var cnt  = parseInt(document.getElementById('linecount').value);
		KeyPts.push({colorValue:0,lineIndex:cnt-1, id:""});		
	}
	onLineCount(null);
}

function deleteKp(_i)  {
	KeyPts.splice(_i,1)
	onLineCount(null);	
}

function onLoad() {
	addKeyPoint();
	addKeyPoint();
	refreshPal();
  }

function findNextNumberInString(_str, _index) {
	while(true) {
		var c = _str.charAt(_index++);
		if (c>='0' && c<='9') 
			break;
	}
	var nStr = "";
	_index--;
	while(true) {
		var c = _str.charAt(_index++);
		if (c>='0' && c<='9') nStr += c;
		else break;
	}
	var num = parseInt(nStr);
	return {n:num,i:_index};
}

function findNextHexNumberInString(_str, _index) {
	while(true) {
		var c = _str.charAt(_index++);
		if (c=='#') 
			break;
	}
	var nStr = "";
	while(true) {
		var c = _str.charAt(_index++);
		if (c>='0' && c<='9') nStr += c;
		else if (c>='a' && c<='f') nStr += c;
		else if (c>='A' && c<='F') nStr += c;
		else break;
	}
	var num = parseInt(nStr,16);
	return {n:num,i:_index};
}

function loadPal() {
	KeyPts = [];
	var xp = document.getElementById('export');
	var index = xp.value.indexOf("grdmstr_data:");
	if (index < 0) {
		alert("ERROR: could not find string 'grdmstr_data:'");
		return;
	}
	var next = findNextNumberInString(xp.value,index);
	var keypCount = next.n;
	index = next.i;
	next = findNextNumberInString(xp.value,index);
	var lineCount = next.n;
	index = next.i;
	document.getElementById('linecount').value = lineCount.toString();
	index = xp.value.indexOf("hsv:");
	if (index < 0) {
		alert("ERROR: could not find string 'hsv:'");
		return;
	}
	next = findNextNumberInString(xp.value,index);
	var hval = next.n.toString();
	document.getElementById('hue').value = hval;
	index = next.i;
	next = findNextNumberInString(xp.value,index);
	var sval = next.n.toString();
	document.getElementById('saturation').value = sval;
	index = next.i;
	next = findNextNumberInString(xp.value,index);
	var vval = next.n.toString();
	document.getElementById('value').value = vval;
	index = next.i;

	for (var i = 0; i < keypCount; i++) {
		next = findNextNumberInString(xp.value,index);
		var lineindex = next.n;
		index = next.i;
		next = findNextHexNumberInString(xp.value,index);
		var col = next.n;
		index = next.i;		
		KeyPts.push({colorValue:col,lineIndex:lineindex, id:""});
	}
	onLineCount({lines:lineCount, hue:hval, sat:sval, val:vval});
  }
  
  
  
 function onImageDropped() {
	 go();
 }
  
  function settings() {
  }
  
   function closeSettings() {
  }
  
  function validate() {
		precalSrcImg();	
		if (OUT_SETTINGS.noise == 'perlin') setPerlinNoise();
		else if (OUT_SETTINGS.noise == 'simplex') setSimplexNoise();
		else if (OUT_SETTINGS.noise == 'random') setRandomNoise();
  }
  
	var origImg;
	var origCvs;
	var origContext;
	var origImgData;
	var origImgPixels;
	
function setTextColor(picker) {
	document.getElementsByTagName('body')[0].style.color = '#' + picker.toString()
}
	
function findPrevKeyPtIndex(_line){
		var nearest = -1;
		for (var it=0; it<KeyPts.length; it++) {
			if (KeyPts[it].lineIndex <= _line) {
				if (nearest == -1 || KeyPts[it].lineIndex >= KeyPts[nearest].lineIndex)
					nearest = it;
			}
		}
		if (nearest == -1) nearest = 0;
		return KeyPts[nearest];
}

function findNextKeyPtIndex(_line){
		var nearest = -1;		
		for (var it=0; it<KeyPts.length; it++) {
			if (KeyPts[it].lineIndex > _line) {
				if (nearest ==-1 || KeyPts[it].lineIndex <= KeyPts[nearest].lineIndex)
					nearest = it;
			}
		}
		if (nearest == -1) nearest = KeyPts.length-1;
		return KeyPts[nearest];
}

function rgbToHsl(r, g, b) {
  r /= 255, g /= 255, b /= 255;

  var max = Math.max(r, g, b), min = Math.min(r, g, b);
  var h, s, l = (max + min) / 2;

  if (max == min) {
    h = s = 0; // achromatic
  } else {
    var d = max - min;
    s = l > 0.5 ? d / (2 - max - min) : d / (max + min);

    switch (max) {
      case r: h = (g - b) / d + (g < b ? 6 : 0); break;
      case g: h = (b - r) / d + 2; break;
      case b: h = (r - g) / d + 4; break;
    }

    h /= 6;
  }

  return [ h, s, l ];
}

function hslToRgb(h, s, l) {
  var r, g, b;

  if (s == 0) {
    r = g = b = l; // achromatic
  } else {
    function hue2rgb(p, q, t) {
      if (t < 0) t += 1;
      if (t > 1) t -= 1;
      if (t < 1/6) return p + (q - p) * 6 * t;
      if (t < 1/2) return q;
      if (t < 2/3) return p + (q - p) * (2/3 - t) * 6;
      return p;
    }

    var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
    var p = 2 * l - q;

    r = hue2rgb(p, q, h + 1/3);
    g = hue2rgb(p, q, h);
    b = hue2rgb(p, q, h - 1/3);
  }

  return [ r * 255, g * 255, b * 255 ];
}

function doSaturation() {
	/*
	var cnt  = parseInt(document.getElementById('saturation').value);
	for (var ii=0; ii<KeyPts.length; ii++){
		var elem = document.getElementById('colorBox_'+ii.toString());
		var iicol = elem.value;
		while (iicol.charAt(0) == ' ' || iicol.charAt(0) == '#')
			iicol = iicol.substr(1);
		var iival = parseInt(iicol,16);
		var red = (iival >> 16) & 255;
		var green = (iival >> 8) & 255;
		var blue = iival & 255;
		hsl = rgbToHsl(red, green, blue);
		var hue = hsl[0];
		var saturation = hsl[1];
		var value = hsl[2];
		saturation += cnt/100.0;
		if (saturation < 0.0) saturation = 0.0;
		if (saturation > 1.0) saturation = 1.0;
		var rgb = hslToRgb(hue, saturation, value);
		var str = "#";
		str += parseInt(rgb[0]).toString(16);
		str += parseInt(rgb[1]).toString(16);
		str += parseInt(rgb[2]).toString(16);
		elem.value = str;
	}	*/
	refreshPal();
}

function refreshPal() {
	var vhue  = parseInt(document.getElementById('hue').value);		
	var sat  = parseInt(document.getElementById('saturation').value);		
	var val  = parseInt(document.getElementById('value').value);		
	var xp = document.getElementById('export');
	var cnt  = parseInt(document.getElementById('linecount').value);
	xp.value = ";grdmstr_data:"+KeyPts.length+","+cnt+"\n";
	xp.value += ";hsv:"+vhue+","+sat+","+val+"\n";
	
	for (var ii=0; ii<KeyPts.length; ii++){
		KeyPts[ii].lineIndex = parseInt(document.getElementById('index_'+ii.toString()).value);
		var iicol = document.getElementById('colorBox_'+ii.toString()).value;
		while (iicol.charAt(0) == ' ' || iicol.charAt(0) == '#')
			iicol = iicol.substr(1);
		var iival = parseInt(iicol,16);		
		KeyPts[ii].colorValue = iival;
		xp.value += ";"+KeyPts[ii].lineIndex+":#"+iival.toString(16)+"\n";
	}
	
	
	var cnt  = parseInt(document.getElementById('linecount').value);
	var str = "";//"<table style='width:100%'>";
	var r,g,b,nr,ng,nb,pr,pg,pb;
	var colors = [];
	for (var i=0; i<cnt; i++){
		var curKeyp = findPrevKeyPtIndex(i);
		var nextKeyp = findNextKeyPtIndex(i);
		var elm = document.getElementById(curKeyp.id);
		var s = elm.value;
		while (s.charAt(0) == ' ' || s.charAt(0) == '#')
			s = s.substr(1);
		var val = parseInt(s,16);
		if (isNaN(val))
			 alert("Unable to parse number");
		if (curKeyp.lineIndex == i) {
			r = (val >> 16)&0xff;
			g = (val >> 8)&0xff;
			b = val&0xff;
			var nelm = document.getElementById(nextKeyp.id);
			var ns = nelm.value;
			while (ns.charAt(0) == ' ' || ns.charAt(0) == '#')
				ns = ns.substr(1);
			var nval = parseInt(ns,16);
			if (isNaN(nval))
				 alert("Unable to parse number");
			nr = (nval >> 16)&0xff;
			ng = (nval >> 8)&0xff;
			nb = nval&0xff;
			pr = (nr-r)/(nextKeyp.lineIndex-curKeyp.lineIndex);
			pg = (ng-g)/(nextKeyp.lineIndex-curKeyp.lineIndex);
			pb = (nb-b)/(nextKeyp.lineIndex-curKeyp.lineIndex);
		}
		 
		
		var vhue  = parseInt(document.getElementById('hue').value);		
		var sat  = parseInt(document.getElementById('saturation').value);		
		var val  = parseInt(document.getElementById('value').value);		
		var hsl = rgbToHsl(r,g,b);
		var hue = hsl[0];
		var saturation = hsl[1];
		var value = hsl[2];
		hue += (vhue-50.0)/100.0;
		if (hue < 0.0) hue = 0.0;
		if (hue > 1.0) hue = 1.0;
		saturation += (sat-50.0)/100.0;
		if (saturation < 0.0) saturation = 0.0;
		if (saturation > 1.0) saturation = 1.0;
		value += (val-50.0)/100.0;
		if (value < 0.0) value = 0.0;
		if (value > 1.0) value = 1.0;
		var rgb = hslToRgb(hue, saturation, value);
		val = nearestCol(rgb[0],rgb[1],rgb[2]);

		//val = nearestCol(r,g,b);
		colors[i] = val;
		var sval = val.toString(16);
		r += pr;
		g += pg;
		b += pb;
	}

	var outCvs = document.getElementById('outImg');
	outCvs.width = 320;
	outCvs.height = cnt;
	var outContext = outCvs.getContext("2d");
	var outImageData = outContext.getImageData(0, 0, 320, cnt);
	var outPixels = outImageData.data;
	var index = 0;
	
	for (var y = 0; y < cnt; y++) {
		for (var x = 0; x < 320; x++) {
			outPixels[index++] = (colors[y]>>16)&0xf0;
			outPixels[index++] = (colors[y]>>8)&0xf0;
			outPixels[index++] = (colors[y])&0xf0;
			outPixels[index++] = 255;
		}		
	}
	outContext.putImageData(outImageData, 0, 0);
	var vperl = parseInt(document.getElementById('valperline').value);
	xp.value += "\npalette:\n";
	xp.value += "; colors count: " + cnt + "\n";	
	xp.value += "\n\tdc.w\t\t";
	for (y=0;y<cnt;y++) {
			var r = (colors[y]>>16)&0xf0
			var g = (colors[y]>>8)&0xf0;
			var b = (colors[y])&0xf0;
			r>>=4;
			g>>=4;
			b>>=4;
			xp.value += "$"+r.toString(16)+g.toString(16)+b.toString(16);
			if (y != cnt-1) {
				if ((y%vperl) == (vperl-1)) xp.value += "\n\tdc.w\t\t";
				else xp.value += ",";
			}
		}
}	

function onLineIndexChanged(_index) {
	KeyPts[_index].lineIndex = document.getElementById('index_'+_index.toString());
	refreshPal();
}

function onLineCount(param) {
/*	for (var ii=0; ii<KeyPts.length; ii++){
		var ielm = document.getElementById('index_'+ii.toString());
		if (ielm) {
			KeyPts[ii].lineIndex = parseInt(ielm.value);
			var iicol = document.getElementById('colorBox_'+ii.toString()).value;
			while (iicol.charAt(0) == ' ' || iicol.charAt(0) == '#')
				iicol = iicol.substr(1);
			var iival = parseInt(iicol,16);				
			KeyPts[ii].colorValue = iival;			
		}
	}*/
	var mdiv = document.getElementById('content');
	var str = "";//"<table style='width:100%'>";
	if (param != null) {
		str += '<label for="Hue">Hue: </label><input type="range" min="1" max="100" value=' + param.hue +' class="slider" id="hue" oninput="doSaturation()"><br>';
		str += '<label for="Saturation">Saturation: </label><input type="range" min="1" max="100" value=' + param.sat +' class="slider" id="saturation" oninput="doSaturation()"><br>';
		str += '<label for="Value">Value: </label><input type="range" min="1" max="100" value=' + param.val +' class="slider" id="value" oninput="doSaturation()"><br>';
	} else {
		str += '<label for="Hue">Hue: </label><input type="range" min="1" max="100" value="50" class="slider" id="hue" oninput="doSaturation()"><br>';
		str += '<label for="Saturation">Saturation: </label><input type="range" min="1" max="100" value="50" class="slider" id="saturation" oninput="doSaturation()"><br>';
		str += '<label for="Value">Value: </label><input type="range" min="1" max="100" value="50" class="slider" id="value" oninput="doSaturation()"><br>';
	}
	str += '<br>';
	str += '<button class="inset" onclick="addKeyPoint();"><i class="fa fa-plus-square"></i> Add Keypoint</button>';
	str += '<button class="inset" onclick="refreshPal();"><i class="fa fa-star"></i> Refresh</button>';
	str += '<br>';

	for (var i=0; i<KeyPts.length; i++){
		KeyPts[i].id = "colorBox_"+i.toString();
		var kcol = KeyPts[i].colorValue;
		str += "<br>";//"<tr><td>";
		str += '<input id="colorBox_'+i+'" onchange="refreshPal" type="color" value="#' + kcol.toString(16) + '" style="width=\"100%\"">';
		//str +=  '<input id="label_'+i+'" type="text" value="#'+col.toString()+'">';
		str +=  '<input id="index_'+i+"\" onchange="+"'onLineIndexChanged("+i.toString() + ");'"+ ' type="text" value="'+KeyPts[i].lineIndex.toString()+'">';
		//str +=  '<button type="button" onclick="deleteKp('+i.toString()+');">X</button>';
		str +=  '<button onclick="deleteKp('+i.toString()+');" class="small"><i class="fa fa-minus-square"></i></button>';
	}
	str += '<br>';
	var newParam = {lines:"256", hue:"50", sat:"50", val:"50"};
	if (document.getElementById('linecount'))
		newParam.lines = document.getElementById('linecount').value;
	if (document.getElementById('hue'))
		newParam.hue = document.getElementById('hue').value;
	if (document.getElementById('saturation'))
		newParam.sat = document.getElementById('saturation').value;
	if (document.getElementById('value'))
		newParam.val = document.getElementById('value').value;
	
	if (param != null) newParam = param;
	var sparam = "{lines:"+newParam.lines+",hue:"+newParam.hue+",sat:"+newParam.sat+",val:"+newParam.val+"}";
		
  if (param != null)
	str += "<br>Line Count: <input type='text' id='linecount'  onchange='onLineCount("+sparam+");' value=" + param.lines + ">";
   else
	str += "<br>Line Count: <input type='text' id='linecount'  onchange='onLineCount("+sparam+");' value='256'>";
	//str += "</table>";
	mdiv.innerHTML = str;
	
	refreshPal();

	$('#thisdiv').load(document.URL +  ' #thisdiv');	
}
	
  function go() {
		// build reference image data
		origImg = document.getElementById('refImg');
		origCvs = document.createElement('canvas');
		origCvs.width = origImg.width;
		origCvs.height = origImg.height;
		origContext = origCvs.getContext('2d');
		origContext.drawImage(origImg,0,0,origImg.width,origImg.height);
		origImgData = origContext.getImageData(0, 0, origImg.width, origImg.height);
		origImgPixels = origImgData.data;
		  
		// build out  image data
		var outCvs = document.getElementById('outImg');
		outCvs.width = origImg.width;
		outCvs.height = origImg.height;
		var outContext = outCvs.getContext("2d");
        var outImageData = outContext.getImageData(0, 0, origImg.width, origImg.height);
        var outPixels = outImageData.data;

		// invoke generator
		var gen = new gen_rgb();
		gen.generate_clamp(origImgPixels, outPixels, origImg.width, origImg.height);
		outContext.putImageData(outImageData, 0, 0);

		var outCvs2 = document.getElementById('outImg2');
		outCvs2.width = origImg.width;
		outCvs2.height = origImg.height;
		var outContext2 = outCvs2.getContext("2d");
        var outImageData2 = outContext2.getImageData(0, 0, origImg.width, origImg.height);
        var outPixels2 = outImageData2.data;
		gen.generate_near(origImgPixels, outPixels2, origImg.width, origImg.height);
		outContext2.putImageData(outImageData2, 0, 0);
  }
 
 function nearestCol(_r,_g,_b) {
	 var rr = nearest(_r);
	 var gg = nearest(_g);
	 var bb = nearest(_b);
	 return (rr<<16)+(gg<<8)+bb;
 }
 
 function nearest(val) {
		var res = val & 0xf0;
		if ((val & 15) >= 8)
			res += 0x10;
		if (res > 0xf0)
			res = 0xf0;
		return res;
}
	
 function onHtmlCol() {
	var src = document.getElementById('stng_htmlCol');
	var dest = document.getElementById('smallbox1');
	var dest2 = document.getElementById('smallbox2');
	var dest3 = document.getElementById('smallbox3');
	var s = src.value;
	while (s.charAt(0) == ' ' || s.charAt(0) == '#')
		s = s.substr(1);
	var val = parseInt(s,16);
	if (isNaN(val))
		 alert("Unable to parse number");
	else
	
	dest.style.backgroundColor  = '#'+s;
	
	var blue = val & 255;
	var green = (val >> 8) & 255;
	var red = (val >> 16) & 255;
	blue &= 0xF0;
	green &= 0xF0;
	red &= 0xF0;
	var amigacol = red.toString(16)+green.toString(16)+blue.toString(16);
	dest2.style.backgroundColor  = '#'+amigacol;
	document.getElementById('stng_AmigaCol1').value = amigacol;

	blue = nearest(val & 255);
	green = nearest((val >> 8) & 255);
	red = nearest((val >> 16) & 255);
	blue &= 0xF0;
	green &= 0xF0;
	red &= 0xF0;
	amigacol = red.toString(16)+green.toString(16)+blue.toString(16);
	dest3.style.backgroundColor  = '#'+amigacol;
	document.getElementById('stng_AmigaCol2').value = amigacol;
}

global_palette = [];
globl_refImgPal = [];

function getPaletteIndex(_r,_g,_b) {
		for (var i = 0; i < global_palette.length; i++) {
			if ((global_palette[i].r == _r)&&(global_palette[i].g == _g)&&(global_palette[i].b == _b))
				return i;
		}
		global_palette.push({r:_r,g:_g,b:_b});
		return global_palette.length-1;
}

function palettize(_refPix, _width, _height) {
		var t = this;

		var i = 0;
		global_palette = [];
		globl_refImgPal = [];
		// ret.push();
		
		for (var y=0;y<_height;y++) {
			for (var x=0;x<_width;x++){
				var val = getPaletteIndex(_refPix[i+0],_refPix[i+1],_refPix[i+2]);
				globl_refImgPal.push(parseInt(val));
				i+=4;
			}
		}
}

function clampPalEntry(_e)	{
	var r = _e.r&0xf0;
	var g = _e.g&0xf0;
	var b = _e.b&0xf0;
	r >>= 4;
	g >>= 4;
	b >>= 4;
	return r.toString(16)+g.toString(16)+b.toString(16);
}

function nearestPalEntry(_e)	{
	var r = _e.r & 0xf0;
	if ((r & 15) >= 8)
		r += 0x10;
	if (r > 0xf0)
		r = 0xf0;

	var g = _e.g & 0xf0;
	if ((g & 15) >= 8)
		g += 0x10;
	if (g > 0xf0)
		g = 0xf0;

	var b = _e.b & 0xf0;
	if ((b & 15) >= 8)
		b += 0x10;
	if (b > 0xf0)
		b = 0xf0;

	r >>= 4;
	g >>= 4;
	b >>= 4;
	return r.toString(16)+g.toString(16)+b.toString(16);
}

function xportPalette() {
		var t = this;
		var i = 0;

		var xp = document.getElementById('export');
		xp.value = "palette:\n";

		xp.value += "; colors count: " + origImg.height + "\n";
		for (var y=0;y<origImg.height;y++) {
			for (var x=0;x<1;x++){
				var r = origImgPixels[y*4*origImg.width];
				var g = origImgPixels[y*4*origImg.width+1];
				var b = origImgPixels[y*4*origImg.width+2];
				r>>=4;
				g>>=4;
				b>>=4;
				xp.value += "\tdc.w\t$"+r.toString(16)+g.toString(16)+b.toString(16)+"\n";
			}
		}
	
}


function xportNearest() {
	palettize(origImgPixels, origImg.width, origImg.height);
	var xp = document.getElementById('export');
	xp.value = "colors_count:\tdc.w " + global_palette.length.toString() +"\npalette:\tdc.w\t";
	for (var i = 0; i < global_palette.length; i++) {		
		xp.value += "$"+nearestPalEntry(global_palette[i]);
		if (i<global_palette.length-1) xp.value += ",";
	}
}
